library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity schieberegister is
    Port ( CLOCK6MHZ : in  STD_LOGIC;
           RESET : in  STD_LOGIC;
           BITIN : in  STD_LOGIC;
           VIERBIT : out  STD_LOGIC_VECTOR (3 downto 0));
end schieberegister;

architecture Verhalten_Schieberegister of schieberegister is
    signal sig_d       : std_logic_vector (3 downto 0) := "0000";
    signal sig_q       : std_logic_vector (3 downto 0) := "0000";
	 signal clock1Hz    : std_logic := '0';
	 signal all_reset   : std_logic := '1';
    signal zaehler     : integer range 0 to 2999999 := 0;	 
	 
	 --Dauerhaftes Logisch-High-Signal, um den Enable-Eingang CE des FDCE dauerhaft High zu setzen.
	 signal eins        : std_logic := '1';
begin						
-- Erzeugen der 1Hz-Clock mit Hilfe eines Prozesses (vergl. Blink-LED)
   process begin
        wait until rising_edge(CLOCK6MHZ);
        if (zaehler<2999999) then
            zaehler <= zaehler+1;
        else
            zaehler <= 0;
            clock1Hz <= not clock1Hz;
        end if;
   end process;
-- Vier D-FlipFlops instanziieren
--	FLIP3: entity FDCE_instanz
	FLIP3: FDCE
	    port map(D => sig_d(3), C => clock1Hz, CLR => not all_reset, Q => sig_q(3), CE => eins);
	FLIP2: FDCE
	    port map(D => sig_d(2), C => clock1Hz, CLR => not all_reset, Q => sig_q(2), CE => eins);
	FLIP1: FDCE
	    port map(D => sig_d(1), C => clock1Hz, CLR => not all_reset, Q => sig_q(1), CE => eins);
	FLIP0: FDCE
	    port map(D => sig_d(0), C => clock1Hz, CLR => not all_reset, Q => sig_q(0), CE => eins);
-- Signalwege / Verbindungen laut Schaltplan beschreiben
   -- Verbindungen zwischen den D-FlipFlops und zum Eingangsschalter
   sig_d(0) <= not BITIN;
	sig_d(1) <= sig_q(0);
	sig_d(2) <= sig_q(1);
	sig_d(3) <= sig_q(2);
	-- Verbindungen zu den LEDs
	VIERBIT(3) <= sig_q(3);
	VIERBIT(2) <= sig_q(2);
	VIERBIT(1) <= sig_q(1);
	VIERBIT(0) <= sig_q(0);
end Verhalten_Schieberegister;

